#include <Encoder.h>
#include <EEPROM.h>
#include <TimedAction.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);

Encoder myEnc(2,3);
Encoder myEnc2(5,6);

int   st    = 100; // step
int   dl    = 2;   // time in fadeloops
int   led   = 9;   // Output 1
int   btn   = 4;   // Button 1
int   led2  = 10;  // Output 2
int   btn2  = 7;   // Buttonp 2

long  val,old,val2,old2,ok1,ok2;
bool  onoff,onoff2;
int   knapp,knapp2;
int   lys,lys2,pr1,pr2;

// I2C Display
void sr(){
  if (val != ok1 or val2 != ok2) {
    pr1 = map(val ,0, st,0,100);
    pr2 = map(val2,0, st,0,100);
    lcd.setCursor(4, 0);
    String tmp = String(pr1);
    if(tmp.length()==2) tmp=" " +tmp;
    if(tmp.length()==1) tmp="  "+tmp;
    lcd.print(tmp);
    lcd.setCursor(10, 0);
    if(onoff == true )lcd.print(" ON ");
    if(onoff == false)lcd.print(" OFF");
  
    lcd.setCursor(4, 1);
    tmp = String(pr2);
    if(tmp.length()==2) tmp=" "+tmp;
    if(tmp.length()==1) tmp="  "+tmp;
    lcd.print(tmp);
    lcd.setCursor(10, 1);
    if(onoff2 == true )lcd.print(" ON ");
    if(onoff2 == false)lcd.print(" OFF");
    
    ok1 = val;
    ok2 = val2;
  }
}

TimedAction serie = TimedAction(200, sr);

void setup() {
  lcd.begin(16, 2);
  lcd.print(" Lovund.org");
  lcd.setCursor(0, 1);
  lcd.print("Dimmer V2.2");
  delay(1000);
  lcd.clear();
  pinMode(led,OUTPUT);
  pinMode(btn,INPUT_PULLUP);
  pinMode(led2,OUTPUT);
  pinMode(btn2,INPUT_PULLUP);
  val     = EEPROM.read(1);
  val2    = EEPROM.read(3);
  onoff   = EEPROM.read(10);
  onoff2  = EEPROM.read(12);
  old     = val;
  old2    = val2;
  myEnc.write(val);
  myEnc2.write(val2);

  pr1 = map(val ,0, st,0,100);
  pr2 = map(val2,0, st,0,100);
  
  lcd.setCursor(0, 0);
  lcd.print("1 :     %");
  lcd.setCursor(4, 0);
  String tmp = String(pr1);
  if(tmp.length()==2) tmp=" " +tmp;
  if(tmp.length()==1) tmp="  "+tmp;
  lcd.print(tmp);
  lcd.setCursor(10, 0);
  if(onoff == true )lcd.print(" ON");
  if(onoff == false)lcd.print(" OFF");
  
  lcd.setCursor(0, 1);
  lcd.print("2 :     %");
  lcd.setCursor(4, 1);
  tmp = String(pr2);
  if(tmp.length()==2) tmp=" " +tmp;
  if(tmp.length()==1) tmp="  "+tmp;
  lcd.print(tmp);
  lcd.setCursor(10, 1);
  if(onoff2 == true )lcd.print(" ON");
  if(onoff2 == false)lcd.print(" OFF");
  
  if (onoff == true) {
    for(int x = 0; x<val;x++){
      analogWrite(led,x);
      delay(dl*10);
    }
    analogWrite(led,val);
  }
  if (onoff2 == true) {
    for(int x = 0; x<val2;x++){
      analogWrite(led2,x);
      delay(dl*10);
    }
    analogWrite(led2,val2);
  }
}

void kan1() {
  if(onoff == true){
    val = constrain(myEnc.read(),0,st);
  }
  myEnc.write(val);
  lys     = map(val,0,st,2,255);
  knapp   = digitalRead(btn);
  if(knapp == LOW and onoff == false){
    onoff = true;
    EEPROM.write(10, onoff);
    EEPROM.write(1, val);
    delay(500);
    k1();
  }
  knapp = digitalRead(btn);
  if(knapp == LOW and onoff == true ) {
    onoff = false;
    EEPROM.write(10, onoff);
    EEPROM.write(1, val);
    delay(500);
    k1();
  }
  if (val != old) {
    old = val;
    EEPROM.write(1, val);
  }
  if(onoff == true) analogWrite(led,lys);
}

void kan2(){
  if (onoff2 == true ){
    val2  = constrain(myEnc2.read(),0,st);
  }
  myEnc2.write(val2);
  lys2    = map(val2,0,st,2,255);
  knapp2  = digitalRead(btn2);
  if(knapp2 == LOW and onoff2 == false){
    onoff2 = true;
    EEPROM.write(12, onoff2);
    EEPROM.write(3, val2);
    delay(500);
    k2();
  }
  knapp2 = digitalRead(btn2);
  if(knapp2 == LOW and onoff2 == true ) {
    onoff2 = false;
    EEPROM.write(12, onoff2);
    EEPROM.write(3, val2);
    delay(500);
    k2();
  }
  if (val2 != old2) {
    old2 = val2;
    EEPROM.write(3, val2);
  }
  if(onoff2 == true) analogWrite(led2,lys2);
}

void k1(){
  lcd.setCursor(10, 0);
  if (onoff  == true ) {
    for(int x = 0 ; x < lys ; x++){
      analogWrite(led,x);
      delay(dl);
    }
    analogWrite(led,lys);
    lcd.print(" ON ");
  }
  
  if (onoff  == false) {
    for(int x = lys ; x > 0 ; x--){
      analogWrite(led,x);
      delay(dl);
    }
    analogWrite(led,0);
    lcd.print(" OFF");
  }
}

void k2(){
  lcd.setCursor(10, 1);
  if (onoff2  == true ) {
    for(int x = 0 ; x < lys2 ; x++){
      analogWrite(led2,x);
      delay(dl);
    }
    analogWrite(led2,lys2);
    lcd.print(" ON ");
  }
  
  if (onoff2  == false) {
    for(int x = lys2 ; x > 0 ; x--){
      analogWrite(led2,x);
      delay(dl);
    }
    analogWrite(led2,0);
    lcd.print(" OFF");
  }
}

void loop(){
  kan1();
  kan2();
  serie.check();
}

